// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from gc_spl_interfaces:msg/RCGCD14.idl
// generated code does not contain a copyright notice

#ifndef GC_SPL_INTERFACES__MSG__DETAIL__RCGCD14__FUNCTIONS_H_
#define GC_SPL_INTERFACES__MSG__DETAIL__RCGCD14__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "gc_spl_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "gc_spl_interfaces/msg/detail/rcgcd14__struct.h"

/// Initialize msg/RCGCD14 message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * gc_spl_interfaces__msg__RCGCD14
 * )) before or use
 * gc_spl_interfaces__msg__RCGCD14__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
bool
gc_spl_interfaces__msg__RCGCD14__init(gc_spl_interfaces__msg__RCGCD14 * msg);

/// Finalize msg/RCGCD14 message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
void
gc_spl_interfaces__msg__RCGCD14__fini(gc_spl_interfaces__msg__RCGCD14 * msg);

/// Create msg/RCGCD14 message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * gc_spl_interfaces__msg__RCGCD14__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
gc_spl_interfaces__msg__RCGCD14 *
gc_spl_interfaces__msg__RCGCD14__create();

/// Destroy msg/RCGCD14 message.
/**
 * It calls
 * gc_spl_interfaces__msg__RCGCD14__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
void
gc_spl_interfaces__msg__RCGCD14__destroy(gc_spl_interfaces__msg__RCGCD14 * msg);

/// Check for msg/RCGCD14 message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
bool
gc_spl_interfaces__msg__RCGCD14__are_equal(const gc_spl_interfaces__msg__RCGCD14 * lhs, const gc_spl_interfaces__msg__RCGCD14 * rhs);

/// Copy a msg/RCGCD14 message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
bool
gc_spl_interfaces__msg__RCGCD14__copy(
  const gc_spl_interfaces__msg__RCGCD14 * input,
  gc_spl_interfaces__msg__RCGCD14 * output);

/// Initialize array of msg/RCGCD14 messages.
/**
 * It allocates the memory for the number of elements and calls
 * gc_spl_interfaces__msg__RCGCD14__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
bool
gc_spl_interfaces__msg__RCGCD14__Sequence__init(gc_spl_interfaces__msg__RCGCD14__Sequence * array, size_t size);

/// Finalize array of msg/RCGCD14 messages.
/**
 * It calls
 * gc_spl_interfaces__msg__RCGCD14__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
void
gc_spl_interfaces__msg__RCGCD14__Sequence__fini(gc_spl_interfaces__msg__RCGCD14__Sequence * array);

/// Create array of msg/RCGCD14 messages.
/**
 * It allocates the memory for the array and calls
 * gc_spl_interfaces__msg__RCGCD14__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
gc_spl_interfaces__msg__RCGCD14__Sequence *
gc_spl_interfaces__msg__RCGCD14__Sequence__create(size_t size);

/// Destroy array of msg/RCGCD14 messages.
/**
 * It calls
 * gc_spl_interfaces__msg__RCGCD14__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
void
gc_spl_interfaces__msg__RCGCD14__Sequence__destroy(gc_spl_interfaces__msg__RCGCD14__Sequence * array);

/// Check for msg/RCGCD14 message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
bool
gc_spl_interfaces__msg__RCGCD14__Sequence__are_equal(const gc_spl_interfaces__msg__RCGCD14__Sequence * lhs, const gc_spl_interfaces__msg__RCGCD14__Sequence * rhs);

/// Copy an array of msg/RCGCD14 messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_gc_spl_interfaces
bool
gc_spl_interfaces__msg__RCGCD14__Sequence__copy(
  const gc_spl_interfaces__msg__RCGCD14__Sequence * input,
  gc_spl_interfaces__msg__RCGCD14__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // GC_SPL_INTERFACES__MSG__DETAIL__RCGCD14__FUNCTIONS_H_
