// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gc_spl_interfaces:msg/RCGCD14.idl
// generated code does not contain a copyright notice

#ifndef GC_SPL_INTERFACES__MSG__DETAIL__RCGCD14__TRAITS_HPP_
#define GC_SPL_INTERFACES__MSG__DETAIL__RCGCD14__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "gc_spl_interfaces/msg/detail/rcgcd14__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'teams'
#include "gc_spl_interfaces/msg/detail/team_info14__traits.hpp"

namespace gc_spl_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const RCGCD14 & msg,
  std::ostream & out)
{
  out << "{";
  // member: packet_number
  {
    out << "packet_number: ";
    rosidl_generator_traits::value_to_yaml(msg.packet_number, out);
    out << ", ";
  }

  // member: players_per_team
  {
    out << "players_per_team: ";
    rosidl_generator_traits::value_to_yaml(msg.players_per_team, out);
    out << ", ";
  }

  // member: competition_phase
  {
    out << "competition_phase: ";
    rosidl_generator_traits::value_to_yaml(msg.competition_phase, out);
    out << ", ";
  }

  // member: competition_type
  {
    out << "competition_type: ";
    rosidl_generator_traits::value_to_yaml(msg.competition_type, out);
    out << ", ";
  }

  // member: game_phase
  {
    out << "game_phase: ";
    rosidl_generator_traits::value_to_yaml(msg.game_phase, out);
    out << ", ";
  }

  // member: state
  {
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
    out << ", ";
  }

  // member: set_play
  {
    out << "set_play: ";
    rosidl_generator_traits::value_to_yaml(msg.set_play, out);
    out << ", ";
  }

  // member: first_half
  {
    out << "first_half: ";
    rosidl_generator_traits::value_to_yaml(msg.first_half, out);
    out << ", ";
  }

  // member: kicking_team
  {
    out << "kicking_team: ";
    rosidl_generator_traits::value_to_yaml(msg.kicking_team, out);
    out << ", ";
  }

  // member: secs_remaining
  {
    out << "secs_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.secs_remaining, out);
    out << ", ";
  }

  // member: secondary_time
  {
    out << "secondary_time: ";
    rosidl_generator_traits::value_to_yaml(msg.secondary_time, out);
    out << ", ";
  }

  // member: teams
  {
    if (msg.teams.size() == 0) {
      out << "teams: []";
    } else {
      out << "teams: [";
      size_t pending_items = msg.teams.size();
      for (auto item : msg.teams) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RCGCD14 & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: packet_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "packet_number: ";
    rosidl_generator_traits::value_to_yaml(msg.packet_number, out);
    out << "\n";
  }

  // member: players_per_team
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "players_per_team: ";
    rosidl_generator_traits::value_to_yaml(msg.players_per_team, out);
    out << "\n";
  }

  // member: competition_phase
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "competition_phase: ";
    rosidl_generator_traits::value_to_yaml(msg.competition_phase, out);
    out << "\n";
  }

  // member: competition_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "competition_type: ";
    rosidl_generator_traits::value_to_yaml(msg.competition_type, out);
    out << "\n";
  }

  // member: game_phase
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "game_phase: ";
    rosidl_generator_traits::value_to_yaml(msg.game_phase, out);
    out << "\n";
  }

  // member: state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
    out << "\n";
  }

  // member: set_play
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "set_play: ";
    rosidl_generator_traits::value_to_yaml(msg.set_play, out);
    out << "\n";
  }

  // member: first_half
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "first_half: ";
    rosidl_generator_traits::value_to_yaml(msg.first_half, out);
    out << "\n";
  }

  // member: kicking_team
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "kicking_team: ";
    rosidl_generator_traits::value_to_yaml(msg.kicking_team, out);
    out << "\n";
  }

  // member: secs_remaining
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "secs_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.secs_remaining, out);
    out << "\n";
  }

  // member: secondary_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "secondary_time: ";
    rosidl_generator_traits::value_to_yaml(msg.secondary_time, out);
    out << "\n";
  }

  // member: teams
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.teams.size() == 0) {
      out << "teams: []\n";
    } else {
      out << "teams:\n";
      for (auto item : msg.teams) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RCGCD14 & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace gc_spl_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gc_spl_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gc_spl_interfaces::msg::RCGCD14 & msg,
  std::ostream & out, size_t indentation = 0)
{
  gc_spl_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gc_spl_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const gc_spl_interfaces::msg::RCGCD14 & msg)
{
  return gc_spl_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<gc_spl_interfaces::msg::RCGCD14>()
{
  return "gc_spl_interfaces::msg::RCGCD14";
}

template<>
inline const char * name<gc_spl_interfaces::msg::RCGCD14>()
{
  return "gc_spl_interfaces/msg/RCGCD14";
}

template<>
struct has_fixed_size<gc_spl_interfaces::msg::RCGCD14>
  : std::integral_constant<bool, has_fixed_size<gc_spl_interfaces::msg::TeamInfo14>::value> {};

template<>
struct has_bounded_size<gc_spl_interfaces::msg::RCGCD14>
  : std::integral_constant<bool, has_bounded_size<gc_spl_interfaces::msg::TeamInfo14>::value> {};

template<>
struct is_message<gc_spl_interfaces::msg::RCGCD14>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GC_SPL_INTERFACES__MSG__DETAIL__RCGCD14__TRAITS_HPP_
