// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gc_spl_interfaces:msg/RCGCRD4.idl
// generated code does not contain a copyright notice

#ifndef GC_SPL_INTERFACES__MSG__DETAIL__RCGCRD4__TRAITS_HPP_
#define GC_SPL_INTERFACES__MSG__DETAIL__RCGCRD4__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "gc_spl_interfaces/msg/detail/rcgcrd4__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace gc_spl_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const RCGCRD4 & msg,
  std::ostream & out)
{
  out << "{";
  // member: player_num
  {
    out << "player_num: ";
    rosidl_generator_traits::value_to_yaml(msg.player_num, out);
    out << ", ";
  }

  // member: team_num
  {
    out << "team_num: ";
    rosidl_generator_traits::value_to_yaml(msg.team_num, out);
    out << ", ";
  }

  // member: fallen
  {
    out << "fallen: ";
    rosidl_generator_traits::value_to_yaml(msg.fallen, out);
    out << ", ";
  }

  // member: pose
  {
    if (msg.pose.size() == 0) {
      out << "pose: []";
    } else {
      out << "pose: [";
      size_t pending_items = msg.pose.size();
      for (auto item : msg.pose) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: ball_age
  {
    out << "ball_age: ";
    rosidl_generator_traits::value_to_yaml(msg.ball_age, out);
    out << ", ";
  }

  // member: ball
  {
    if (msg.ball.size() == 0) {
      out << "ball: []";
    } else {
      out << "ball: [";
      size_t pending_items = msg.ball.size();
      for (auto item : msg.ball) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RCGCRD4 & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: player_num
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "player_num: ";
    rosidl_generator_traits::value_to_yaml(msg.player_num, out);
    out << "\n";
  }

  // member: team_num
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "team_num: ";
    rosidl_generator_traits::value_to_yaml(msg.team_num, out);
    out << "\n";
  }

  // member: fallen
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fallen: ";
    rosidl_generator_traits::value_to_yaml(msg.fallen, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.pose.size() == 0) {
      out << "pose: []\n";
    } else {
      out << "pose:\n";
      for (auto item : msg.pose) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: ball_age
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ball_age: ";
    rosidl_generator_traits::value_to_yaml(msg.ball_age, out);
    out << "\n";
  }

  // member: ball
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.ball.size() == 0) {
      out << "ball: []\n";
    } else {
      out << "ball:\n";
      for (auto item : msg.ball) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RCGCRD4 & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace gc_spl_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gc_spl_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gc_spl_interfaces::msg::RCGCRD4 & msg,
  std::ostream & out, size_t indentation = 0)
{
  gc_spl_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gc_spl_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const gc_spl_interfaces::msg::RCGCRD4 & msg)
{
  return gc_spl_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<gc_spl_interfaces::msg::RCGCRD4>()
{
  return "gc_spl_interfaces::msg::RCGCRD4";
}

template<>
inline const char * name<gc_spl_interfaces::msg::RCGCRD4>()
{
  return "gc_spl_interfaces/msg/RCGCRD4";
}

template<>
struct has_fixed_size<gc_spl_interfaces::msg::RCGCRD4>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<gc_spl_interfaces::msg::RCGCRD4>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<gc_spl_interfaces::msg::RCGCRD4>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GC_SPL_INTERFACES__MSG__DETAIL__RCGCRD4__TRAITS_HPP_
