// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from gc_spl_interfaces:msg/RobotInfo14.idl
// generated code does not contain a copyright notice

#ifndef GC_SPL_INTERFACES__MSG__DETAIL__ROBOT_INFO14__STRUCT_HPP_
#define GC_SPL_INTERFACES__MSG__DETAIL__ROBOT_INFO14__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__gc_spl_interfaces__msg__RobotInfo14 __attribute__((deprecated))
#else
# define DEPRECATED__gc_spl_interfaces__msg__RobotInfo14 __declspec(deprecated)
#endif

namespace gc_spl_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RobotInfo14_
{
  using Type = RobotInfo14_<ContainerAllocator>;

  explicit RobotInfo14_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->penalty = 0;
      this->secs_till_unpenalised = 0;
    }
  }

  explicit RobotInfo14_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->penalty = 0;
      this->secs_till_unpenalised = 0;
    }
  }

  // field types and members
  using _penalty_type =
    uint8_t;
  _penalty_type penalty;
  using _secs_till_unpenalised_type =
    uint8_t;
  _secs_till_unpenalised_type secs_till_unpenalised;

  // setters for named parameter idiom
  Type & set__penalty(
    const uint8_t & _arg)
  {
    this->penalty = _arg;
    return *this;
  }
  Type & set__secs_till_unpenalised(
    const uint8_t & _arg)
  {
    this->secs_till_unpenalised = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t PENALTY_NONE =
    0u;
  static constexpr uint8_t PENALTY_SPL_ILLEGAL_BALL_CONTACT =
    1u;
  static constexpr uint8_t PENALTY_SPL_PLAYER_PUSHING =
    2u;
  static constexpr uint8_t PENALTY_SPL_ILLEGAL_MOTION_IN_SET =
    3u;
  static constexpr uint8_t PENALTY_SPL_INACTIVE_PLAYER =
    4u;
  static constexpr uint8_t PENALTY_SPL_ILLEGAL_POSITION =
    5u;
  static constexpr uint8_t PENALTY_SPL_LEAVING_THE_FIELD =
    6u;
  static constexpr uint8_t PENALTY_SPL_REQUEST_FOR_PICKUP =
    7u;
  static constexpr uint8_t PENALTY_SPL_LOCAL_GAME_STUCK =
    8u;
  static constexpr uint8_t PENALTY_SPL_ILLEGAL_POSITION_IN_SET =
    9u;
  static constexpr uint8_t PENALTY_SUBSTITUTE =
    14u;
  static constexpr uint8_t PENALTY_MANUAL =
    15u;

  // pointer types
  using RawPtr =
    gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator> *;
  using ConstRawPtr =
    const gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gc_spl_interfaces__msg__RobotInfo14
    std::shared_ptr<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gc_spl_interfaces__msg__RobotInfo14
    std::shared_ptr<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RobotInfo14_ & other) const
  {
    if (this->penalty != other.penalty) {
      return false;
    }
    if (this->secs_till_unpenalised != other.secs_till_unpenalised) {
      return false;
    }
    return true;
  }
  bool operator!=(const RobotInfo14_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RobotInfo14_

// alias to use template instance with default allocator
using RobotInfo14 =
  gc_spl_interfaces::msg::RobotInfo14_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_NONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SPL_ILLEGAL_BALL_CONTACT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SPL_PLAYER_PUSHING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SPL_ILLEGAL_MOTION_IN_SET;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SPL_INACTIVE_PLAYER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SPL_ILLEGAL_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SPL_LEAVING_THE_FIELD;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SPL_REQUEST_FOR_PICKUP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SPL_LOCAL_GAME_STUCK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SPL_ILLEGAL_POSITION_IN_SET;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_SUBSTITUTE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RobotInfo14_<ContainerAllocator>::PENALTY_MANUAL;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace gc_spl_interfaces

#endif  // GC_SPL_INTERFACES__MSG__DETAIL__ROBOT_INFO14__STRUCT_HPP_
