// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gc_spl_interfaces:msg/RobotInfo15.idl
// generated code does not contain a copyright notice

#ifndef GC_SPL_INTERFACES__MSG__DETAIL__ROBOT_INFO15__TRAITS_HPP_
#define GC_SPL_INTERFACES__MSG__DETAIL__ROBOT_INFO15__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "gc_spl_interfaces/msg/detail/robot_info15__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace gc_spl_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const RobotInfo15 & msg,
  std::ostream & out)
{
  out << "{";
  // member: penalty
  {
    out << "penalty: ";
    rosidl_generator_traits::value_to_yaml(msg.penalty, out);
    out << ", ";
  }

  // member: secs_till_unpenalised
  {
    out << "secs_till_unpenalised: ";
    rosidl_generator_traits::value_to_yaml(msg.secs_till_unpenalised, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RobotInfo15 & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: penalty
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "penalty: ";
    rosidl_generator_traits::value_to_yaml(msg.penalty, out);
    out << "\n";
  }

  // member: secs_till_unpenalised
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "secs_till_unpenalised: ";
    rosidl_generator_traits::value_to_yaml(msg.secs_till_unpenalised, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RobotInfo15 & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace gc_spl_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gc_spl_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gc_spl_interfaces::msg::RobotInfo15 & msg,
  std::ostream & out, size_t indentation = 0)
{
  gc_spl_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gc_spl_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const gc_spl_interfaces::msg::RobotInfo15 & msg)
{
  return gc_spl_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<gc_spl_interfaces::msg::RobotInfo15>()
{
  return "gc_spl_interfaces::msg::RobotInfo15";
}

template<>
inline const char * name<gc_spl_interfaces::msg::RobotInfo15>()
{
  return "gc_spl_interfaces/msg/RobotInfo15";
}

template<>
struct has_fixed_size<gc_spl_interfaces::msg::RobotInfo15>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<gc_spl_interfaces::msg::RobotInfo15>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<gc_spl_interfaces::msg::RobotInfo15>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GC_SPL_INTERFACES__MSG__DETAIL__ROBOT_INFO15__TRAITS_HPP_
