// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from gc_spl_interfaces:msg/TeamInfo14.idl
// generated code does not contain a copyright notice

#ifndef GC_SPL_INTERFACES__MSG__DETAIL__TEAM_INFO14__STRUCT_HPP_
#define GC_SPL_INTERFACES__MSG__DETAIL__TEAM_INFO14__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'players'
#include "gc_spl_interfaces/msg/detail/robot_info14__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__gc_spl_interfaces__msg__TeamInfo14 __attribute__((deprecated))
#else
# define DEPRECATED__gc_spl_interfaces__msg__TeamInfo14 __declspec(deprecated)
#endif

namespace gc_spl_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TeamInfo14_
{
  using Type = TeamInfo14_<ContainerAllocator>;

  explicit TeamInfo14_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->team_number = 0;
      this->team_colour = 0;
      this->score = 0;
      this->penalty_shot = 0;
      this->single_shots = 0;
      this->message_budget = 0;
      this->players.fill(gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>{_init});
    }
  }

  explicit TeamInfo14_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : players(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->team_number = 0;
      this->team_colour = 0;
      this->score = 0;
      this->penalty_shot = 0;
      this->single_shots = 0;
      this->message_budget = 0;
      this->players.fill(gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>{_alloc, _init});
    }
  }

  // field types and members
  using _team_number_type =
    uint8_t;
  _team_number_type team_number;
  using _team_colour_type =
    uint8_t;
  _team_colour_type team_colour;
  using _score_type =
    uint8_t;
  _score_type score;
  using _penalty_shot_type =
    uint8_t;
  _penalty_shot_type penalty_shot;
  using _single_shots_type =
    uint16_t;
  _single_shots_type single_shots;
  using _message_budget_type =
    uint16_t;
  _message_budget_type message_budget;
  using _players_type =
    std::array<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>, 7>;
  _players_type players;

  // setters for named parameter idiom
  Type & set__team_number(
    const uint8_t & _arg)
  {
    this->team_number = _arg;
    return *this;
  }
  Type & set__team_colour(
    const uint8_t & _arg)
  {
    this->team_colour = _arg;
    return *this;
  }
  Type & set__score(
    const uint8_t & _arg)
  {
    this->score = _arg;
    return *this;
  }
  Type & set__penalty_shot(
    const uint8_t & _arg)
  {
    this->penalty_shot = _arg;
    return *this;
  }
  Type & set__single_shots(
    const uint16_t & _arg)
  {
    this->single_shots = _arg;
    return *this;
  }
  Type & set__message_budget(
    const uint16_t & _arg)
  {
    this->message_budget = _arg;
    return *this;
  }
  Type & set__players(
    const std::array<gc_spl_interfaces::msg::RobotInfo14_<ContainerAllocator>, 7> & _arg)
  {
    this->players = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t TEAM_BLUE =
    0u;
  static constexpr uint8_t TEAM_RED =
    1u;
  static constexpr uint8_t TEAM_YELLOW =
    2u;
  static constexpr uint8_t TEAM_BLACK =
    3u;
  static constexpr uint8_t TEAM_WHITE =
    4u;
  static constexpr uint8_t TEAM_GREEN =
    5u;
  static constexpr uint8_t TEAM_ORANGE =
    6u;
  static constexpr uint8_t TEAM_PURPLE =
    7u;
  static constexpr uint8_t TEAM_BROWN =
    8u;
  static constexpr uint8_t TEAM_GRAY =
    9u;

  // pointer types
  using RawPtr =
    gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator> *;
  using ConstRawPtr =
    const gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gc_spl_interfaces__msg__TeamInfo14
    std::shared_ptr<gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gc_spl_interfaces__msg__TeamInfo14
    std::shared_ptr<gc_spl_interfaces::msg::TeamInfo14_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TeamInfo14_ & other) const
  {
    if (this->team_number != other.team_number) {
      return false;
    }
    if (this->team_colour != other.team_colour) {
      return false;
    }
    if (this->score != other.score) {
      return false;
    }
    if (this->penalty_shot != other.penalty_shot) {
      return false;
    }
    if (this->single_shots != other.single_shots) {
      return false;
    }
    if (this->message_budget != other.message_budget) {
      return false;
    }
    if (this->players != other.players) {
      return false;
    }
    return true;
  }
  bool operator!=(const TeamInfo14_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TeamInfo14_

// alias to use template instance with default allocator
using TeamInfo14 =
  gc_spl_interfaces::msg::TeamInfo14_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_BLUE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_RED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_YELLOW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_BLACK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_WHITE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_GREEN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_ORANGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_PURPLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_BROWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TeamInfo14_<ContainerAllocator>::TEAM_GRAY;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace gc_spl_interfaces

#endif  // GC_SPL_INTERFACES__MSG__DETAIL__TEAM_INFO14__STRUCT_HPP_
