// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gc_spl_interfaces:msg/TeamInfo15.idl
// generated code does not contain a copyright notice

#ifndef GC_SPL_INTERFACES__MSG__DETAIL__TEAM_INFO15__TRAITS_HPP_
#define GC_SPL_INTERFACES__MSG__DETAIL__TEAM_INFO15__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "gc_spl_interfaces/msg/detail/team_info15__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'players'
#include "gc_spl_interfaces/msg/detail/robot_info15__traits.hpp"

namespace gc_spl_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const TeamInfo15 & msg,
  std::ostream & out)
{
  out << "{";
  // member: team_number
  {
    out << "team_number: ";
    rosidl_generator_traits::value_to_yaml(msg.team_number, out);
    out << ", ";
  }

  // member: field_player_colour
  {
    out << "field_player_colour: ";
    rosidl_generator_traits::value_to_yaml(msg.field_player_colour, out);
    out << ", ";
  }

  // member: goalkeeper_colour
  {
    out << "goalkeeper_colour: ";
    rosidl_generator_traits::value_to_yaml(msg.goalkeeper_colour, out);
    out << ", ";
  }

  // member: goalkeeper
  {
    out << "goalkeeper: ";
    rosidl_generator_traits::value_to_yaml(msg.goalkeeper, out);
    out << ", ";
  }

  // member: team_colour
  {
    out << "team_colour: ";
    rosidl_generator_traits::value_to_yaml(msg.team_colour, out);
    out << ", ";
  }

  // member: score
  {
    out << "score: ";
    rosidl_generator_traits::value_to_yaml(msg.score, out);
    out << ", ";
  }

  // member: penalty_shot
  {
    out << "penalty_shot: ";
    rosidl_generator_traits::value_to_yaml(msg.penalty_shot, out);
    out << ", ";
  }

  // member: single_shots
  {
    out << "single_shots: ";
    rosidl_generator_traits::value_to_yaml(msg.single_shots, out);
    out << ", ";
  }

  // member: message_budget
  {
    out << "message_budget: ";
    rosidl_generator_traits::value_to_yaml(msg.message_budget, out);
    out << ", ";
  }

  // member: players
  {
    if (msg.players.size() == 0) {
      out << "players: []";
    } else {
      out << "players: [";
      size_t pending_items = msg.players.size();
      for (auto item : msg.players) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TeamInfo15 & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: team_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "team_number: ";
    rosidl_generator_traits::value_to_yaml(msg.team_number, out);
    out << "\n";
  }

  // member: field_player_colour
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "field_player_colour: ";
    rosidl_generator_traits::value_to_yaml(msg.field_player_colour, out);
    out << "\n";
  }

  // member: goalkeeper_colour
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goalkeeper_colour: ";
    rosidl_generator_traits::value_to_yaml(msg.goalkeeper_colour, out);
    out << "\n";
  }

  // member: goalkeeper
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goalkeeper: ";
    rosidl_generator_traits::value_to_yaml(msg.goalkeeper, out);
    out << "\n";
  }

  // member: team_colour
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "team_colour: ";
    rosidl_generator_traits::value_to_yaml(msg.team_colour, out);
    out << "\n";
  }

  // member: score
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "score: ";
    rosidl_generator_traits::value_to_yaml(msg.score, out);
    out << "\n";
  }

  // member: penalty_shot
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "penalty_shot: ";
    rosidl_generator_traits::value_to_yaml(msg.penalty_shot, out);
    out << "\n";
  }

  // member: single_shots
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "single_shots: ";
    rosidl_generator_traits::value_to_yaml(msg.single_shots, out);
    out << "\n";
  }

  // member: message_budget
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message_budget: ";
    rosidl_generator_traits::value_to_yaml(msg.message_budget, out);
    out << "\n";
  }

  // member: players
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.players.size() == 0) {
      out << "players: []\n";
    } else {
      out << "players:\n";
      for (auto item : msg.players) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TeamInfo15 & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace gc_spl_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gc_spl_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gc_spl_interfaces::msg::TeamInfo15 & msg,
  std::ostream & out, size_t indentation = 0)
{
  gc_spl_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gc_spl_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const gc_spl_interfaces::msg::TeamInfo15 & msg)
{
  return gc_spl_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<gc_spl_interfaces::msg::TeamInfo15>()
{
  return "gc_spl_interfaces::msg::TeamInfo15";
}

template<>
inline const char * name<gc_spl_interfaces::msg::TeamInfo15>()
{
  return "gc_spl_interfaces/msg/TeamInfo15";
}

template<>
struct has_fixed_size<gc_spl_interfaces::msg::TeamInfo15>
  : std::integral_constant<bool, has_fixed_size<gc_spl_interfaces::msg::RobotInfo15>::value> {};

template<>
struct has_bounded_size<gc_spl_interfaces::msg::TeamInfo15>
  : std::integral_constant<bool, has_bounded_size<gc_spl_interfaces::msg::RobotInfo15>::value> {};

template<>
struct is_message<gc_spl_interfaces::msg::TeamInfo15>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GC_SPL_INTERFACES__MSG__DETAIL__TEAM_INFO15__TRAITS_HPP_
