// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from gc_spl_interfaces:msg/RCGCD15.idl
// generated code does not contain a copyright notice

#ifndef GC_SPL_INTERFACES__MSG__DETAIL__RCGCD15__STRUCT_HPP_
#define GC_SPL_INTERFACES__MSG__DETAIL__RCGCD15__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'teams'
#include "gc_spl_interfaces/msg/detail/team_info15__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__gc_spl_interfaces__msg__RCGCD15 __attribute__((deprecated))
#else
# define DEPRECATED__gc_spl_interfaces__msg__RCGCD15 __declspec(deprecated)
#endif

namespace gc_spl_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RCGCD15_
{
  using Type = RCGCD15_<ContainerAllocator>;

  explicit RCGCD15_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->packet_number = 0;
      this->players_per_team = 0;
      this->competition_phase = 0;
      this->competition_type = 0;
      this->game_phase = 0;
      this->state = 0;
      this->set_play = 0;
      this->first_half = 0;
      this->kicking_team = 0;
      this->secs_remaining = 0;
      this->secondary_time = 0;
      this->teams.fill(gc_spl_interfaces::msg::TeamInfo15_<ContainerAllocator>{_init});
    }
  }

  explicit RCGCD15_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : teams(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->packet_number = 0;
      this->players_per_team = 0;
      this->competition_phase = 0;
      this->competition_type = 0;
      this->game_phase = 0;
      this->state = 0;
      this->set_play = 0;
      this->first_half = 0;
      this->kicking_team = 0;
      this->secs_remaining = 0;
      this->secondary_time = 0;
      this->teams.fill(gc_spl_interfaces::msg::TeamInfo15_<ContainerAllocator>{_alloc, _init});
    }
  }

  // field types and members
  using _packet_number_type =
    uint8_t;
  _packet_number_type packet_number;
  using _players_per_team_type =
    uint8_t;
  _players_per_team_type players_per_team;
  using _competition_phase_type =
    uint8_t;
  _competition_phase_type competition_phase;
  using _competition_type_type =
    uint8_t;
  _competition_type_type competition_type;
  using _game_phase_type =
    uint8_t;
  _game_phase_type game_phase;
  using _state_type =
    uint8_t;
  _state_type state;
  using _set_play_type =
    uint8_t;
  _set_play_type set_play;
  using _first_half_type =
    uint8_t;
  _first_half_type first_half;
  using _kicking_team_type =
    uint8_t;
  _kicking_team_type kicking_team;
  using _secs_remaining_type =
    int16_t;
  _secs_remaining_type secs_remaining;
  using _secondary_time_type =
    int16_t;
  _secondary_time_type secondary_time;
  using _teams_type =
    std::array<gc_spl_interfaces::msg::TeamInfo15_<ContainerAllocator>, 2>;
  _teams_type teams;

  // setters for named parameter idiom
  Type & set__packet_number(
    const uint8_t & _arg)
  {
    this->packet_number = _arg;
    return *this;
  }
  Type & set__players_per_team(
    const uint8_t & _arg)
  {
    this->players_per_team = _arg;
    return *this;
  }
  Type & set__competition_phase(
    const uint8_t & _arg)
  {
    this->competition_phase = _arg;
    return *this;
  }
  Type & set__competition_type(
    const uint8_t & _arg)
  {
    this->competition_type = _arg;
    return *this;
  }
  Type & set__game_phase(
    const uint8_t & _arg)
  {
    this->game_phase = _arg;
    return *this;
  }
  Type & set__state(
    const uint8_t & _arg)
  {
    this->state = _arg;
    return *this;
  }
  Type & set__set_play(
    const uint8_t & _arg)
  {
    this->set_play = _arg;
    return *this;
  }
  Type & set__first_half(
    const uint8_t & _arg)
  {
    this->first_half = _arg;
    return *this;
  }
  Type & set__kicking_team(
    const uint8_t & _arg)
  {
    this->kicking_team = _arg;
    return *this;
  }
  Type & set__secs_remaining(
    const int16_t & _arg)
  {
    this->secs_remaining = _arg;
    return *this;
  }
  Type & set__secondary_time(
    const int16_t & _arg)
  {
    this->secondary_time = _arg;
    return *this;
  }
  Type & set__teams(
    const std::array<gc_spl_interfaces::msg::TeamInfo15_<ContainerAllocator>, 2> & _arg)
  {
    this->teams = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t COMPETITION_PHASE_ROUNDROBIN =
    0u;
  static constexpr uint8_t COMPETIION_PHASE_PLAYOFF =
    1u;
  static constexpr uint8_t COMPETITION_TYPE_NORMAL =
    0u;
  static constexpr uint8_t COMPETITION_TYPE_DYNAMIC_BALL_HANDLING =
    1u;
  static constexpr uint8_t GAME_PHASE_NORMAL =
    0u;
  static constexpr uint8_t GAME_PHASE_PENALTYSHOOT =
    1u;
  static constexpr uint8_t GAME_PHASE_OVERTIME =
    2u;
  static constexpr uint8_t GAME_PHASE_TIMEOUT =
    3u;
  static constexpr uint8_t STATE_INITIAL =
    0u;
  static constexpr uint8_t STATE_READY =
    1u;
  static constexpr uint8_t STATE_SET =
    2u;
  static constexpr uint8_t STATE_PLAYING =
    3u;
  static constexpr uint8_t STATE_FINISHED =
    4u;
  static constexpr uint8_t SET_PLAY_NONE =
    0u;
  static constexpr uint8_t SET_PLAY_GOAL_KICK =
    1u;
  static constexpr uint8_t SET_PLAY_PUSHING_FREE_KICK =
    2u;
  static constexpr uint8_t SET_PLAY_CORNER_KICK =
    3u;
  static constexpr uint8_t SET_PLAY_KICK_IN =
    4u;
  static constexpr uint8_t SET_PLAY_PENALTY_KICK =
    5u;

  // pointer types
  using RawPtr =
    gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator> *;
  using ConstRawPtr =
    const gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gc_spl_interfaces__msg__RCGCD15
    std::shared_ptr<gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gc_spl_interfaces__msg__RCGCD15
    std::shared_ptr<gc_spl_interfaces::msg::RCGCD15_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RCGCD15_ & other) const
  {
    if (this->packet_number != other.packet_number) {
      return false;
    }
    if (this->players_per_team != other.players_per_team) {
      return false;
    }
    if (this->competition_phase != other.competition_phase) {
      return false;
    }
    if (this->competition_type != other.competition_type) {
      return false;
    }
    if (this->game_phase != other.game_phase) {
      return false;
    }
    if (this->state != other.state) {
      return false;
    }
    if (this->set_play != other.set_play) {
      return false;
    }
    if (this->first_half != other.first_half) {
      return false;
    }
    if (this->kicking_team != other.kicking_team) {
      return false;
    }
    if (this->secs_remaining != other.secs_remaining) {
      return false;
    }
    if (this->secondary_time != other.secondary_time) {
      return false;
    }
    if (this->teams != other.teams) {
      return false;
    }
    return true;
  }
  bool operator!=(const RCGCD15_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RCGCD15_

// alias to use template instance with default allocator
using RCGCD15 =
  gc_spl_interfaces::msg::RCGCD15_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::COMPETITION_PHASE_ROUNDROBIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::COMPETIION_PHASE_PLAYOFF;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::COMPETITION_TYPE_NORMAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::COMPETITION_TYPE_DYNAMIC_BALL_HANDLING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::GAME_PHASE_NORMAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::GAME_PHASE_PENALTYSHOOT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::GAME_PHASE_OVERTIME;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::GAME_PHASE_TIMEOUT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::STATE_INITIAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::STATE_READY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::STATE_SET;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::STATE_PLAYING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::STATE_FINISHED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::SET_PLAY_NONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::SET_PLAY_GOAL_KICK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::SET_PLAY_PUSHING_FREE_KICK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::SET_PLAY_CORNER_KICK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::SET_PLAY_KICK_IN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RCGCD15_<ContainerAllocator>::SET_PLAY_PENALTY_KICK;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace gc_spl_interfaces

#endif  // GC_SPL_INTERFACES__MSG__DETAIL__RCGCD15__STRUCT_HPP_
