// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from gc_spl_interfaces:msg/RCGCD15.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "gc_spl_interfaces/msg/detail/rcgcd15__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace gc_spl_interfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void RCGCD15_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) gc_spl_interfaces::msg::RCGCD15(_init);
}

void RCGCD15_fini_function(void * message_memory)
{
  auto typed_message = static_cast<gc_spl_interfaces::msg::RCGCD15 *>(message_memory);
  typed_message->~RCGCD15();
}

size_t size_function__RCGCD15__teams(const void * untyped_member)
{
  (void)untyped_member;
  return 2;
}

const void * get_const_function__RCGCD15__teams(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::array<gc_spl_interfaces::msg::TeamInfo15, 2> *>(untyped_member);
  return &member[index];
}

void * get_function__RCGCD15__teams(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::array<gc_spl_interfaces::msg::TeamInfo15, 2> *>(untyped_member);
  return &member[index];
}

void fetch_function__RCGCD15__teams(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const gc_spl_interfaces::msg::TeamInfo15 *>(
    get_const_function__RCGCD15__teams(untyped_member, index));
  auto & value = *reinterpret_cast<gc_spl_interfaces::msg::TeamInfo15 *>(untyped_value);
  value = item;
}

void assign_function__RCGCD15__teams(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<gc_spl_interfaces::msg::TeamInfo15 *>(
    get_function__RCGCD15__teams(untyped_member, index));
  const auto & value = *reinterpret_cast<const gc_spl_interfaces::msg::TeamInfo15 *>(untyped_value);
  item = value;
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember RCGCD15_message_member_array[12] = {
  {
    "packet_number",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, packet_number),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "players_per_team",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, players_per_team),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "competition_phase",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, competition_phase),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "competition_type",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, competition_type),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "game_phase",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, game_phase),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "state",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, state),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "set_play",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, set_play),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "first_half",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, first_half),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "kicking_team",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, kicking_team),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "secs_remaining",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT16,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, secs_remaining),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "secondary_time",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT16,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, secondary_time),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "teams",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<gc_spl_interfaces::msg::TeamInfo15>(),  // members of sub message
    true,  // is array
    2,  // array size
    false,  // is upper bound
    offsetof(gc_spl_interfaces::msg::RCGCD15, teams),  // bytes offset in struct
    nullptr,  // default value
    size_function__RCGCD15__teams,  // size() function pointer
    get_const_function__RCGCD15__teams,  // get_const(index) function pointer
    get_function__RCGCD15__teams,  // get(index) function pointer
    fetch_function__RCGCD15__teams,  // fetch(index, &value) function pointer
    assign_function__RCGCD15__teams,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers RCGCD15_message_members = {
  "gc_spl_interfaces::msg",  // message namespace
  "RCGCD15",  // message name
  12,  // number of fields
  sizeof(gc_spl_interfaces::msg::RCGCD15),
  RCGCD15_message_member_array,  // message members
  RCGCD15_init_function,  // function to initialize message memory (memory has to be allocated)
  RCGCD15_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t RCGCD15_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &RCGCD15_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace gc_spl_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<gc_spl_interfaces::msg::RCGCD15>()
{
  return &::gc_spl_interfaces::msg::rosidl_typesupport_introspection_cpp::RCGCD15_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, gc_spl_interfaces, msg, RCGCD15)() {
  return &::gc_spl_interfaces::msg::rosidl_typesupport_introspection_cpp::RCGCD15_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
