// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from gc_spl_interfaces:msg/RCGCRD4.idl
// generated code does not contain a copyright notice

#ifndef GC_SPL_INTERFACES__MSG__DETAIL__RCGCRD4__STRUCT_HPP_
#define GC_SPL_INTERFACES__MSG__DETAIL__RCGCRD4__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__gc_spl_interfaces__msg__RCGCRD4 __attribute__((deprecated))
#else
# define DEPRECATED__gc_spl_interfaces__msg__RCGCRD4 __declspec(deprecated)
#endif

namespace gc_spl_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RCGCRD4_
{
  using Type = RCGCRD4_<ContainerAllocator>;

  explicit RCGCRD4_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->player_num = 0;
      this->team_num = 0;
      this->fallen = 0;
      std::fill<typename std::array<float, 3>::iterator, float>(this->pose.begin(), this->pose.end(), 0.0f);
      this->ball_age = -1.0f;
      std::fill<typename std::array<float, 2>::iterator, float>(this->ball.begin(), this->ball.end(), 0.0f);
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->player_num = 0;
      this->team_num = 0;
      this->fallen = 0;
      std::fill<typename std::array<float, 3>::iterator, float>(this->pose.begin(), this->pose.end(), 0.0f);
      this->ball_age = 0.0f;
      std::fill<typename std::array<float, 2>::iterator, float>(this->ball.begin(), this->ball.end(), 0.0f);
    }
  }

  explicit RCGCRD4_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_alloc),
    ball(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->player_num = 0;
      this->team_num = 0;
      this->fallen = 0;
      std::fill<typename std::array<float, 3>::iterator, float>(this->pose.begin(), this->pose.end(), 0.0f);
      this->ball_age = -1.0f;
      std::fill<typename std::array<float, 2>::iterator, float>(this->ball.begin(), this->ball.end(), 0.0f);
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->player_num = 0;
      this->team_num = 0;
      this->fallen = 0;
      std::fill<typename std::array<float, 3>::iterator, float>(this->pose.begin(), this->pose.end(), 0.0f);
      this->ball_age = 0.0f;
      std::fill<typename std::array<float, 2>::iterator, float>(this->ball.begin(), this->ball.end(), 0.0f);
    }
  }

  // field types and members
  using _player_num_type =
    uint8_t;
  _player_num_type player_num;
  using _team_num_type =
    uint8_t;
  _team_num_type team_num;
  using _fallen_type =
    uint8_t;
  _fallen_type fallen;
  using _pose_type =
    std::array<float, 3>;
  _pose_type pose;
  using _ball_age_type =
    float;
  _ball_age_type ball_age;
  using _ball_type =
    std::array<float, 2>;
  _ball_type ball;

  // setters for named parameter idiom
  Type & set__player_num(
    const uint8_t & _arg)
  {
    this->player_num = _arg;
    return *this;
  }
  Type & set__team_num(
    const uint8_t & _arg)
  {
    this->team_num = _arg;
    return *this;
  }
  Type & set__fallen(
    const uint8_t & _arg)
  {
    this->fallen = _arg;
    return *this;
  }
  Type & set__pose(
    const std::array<float, 3> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__ball_age(
    const float & _arg)
  {
    this->ball_age = _arg;
    return *this;
  }
  Type & set__ball(
    const std::array<float, 2> & _arg)
  {
    this->ball = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator> *;
  using ConstRawPtr =
    const gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__gc_spl_interfaces__msg__RCGCRD4
    std::shared_ptr<gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__gc_spl_interfaces__msg__RCGCRD4
    std::shared_ptr<gc_spl_interfaces::msg::RCGCRD4_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RCGCRD4_ & other) const
  {
    if (this->player_num != other.player_num) {
      return false;
    }
    if (this->team_num != other.team_num) {
      return false;
    }
    if (this->fallen != other.fallen) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->ball_age != other.ball_age) {
      return false;
    }
    if (this->ball != other.ball) {
      return false;
    }
    return true;
  }
  bool operator!=(const RCGCRD4_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RCGCRD4_

// alias to use template instance with default allocator
using RCGCRD4 =
  gc_spl_interfaces::msg::RCGCRD4_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace gc_spl_interfaces

#endif  // GC_SPL_INTERFACES__MSG__DETAIL__RCGCRD4__STRUCT_HPP_
